package com.caimei365.user.mapper;

import com.caimei365.user.model.dto.BaikeProductDto;
import com.caimei365.user.model.po.BaikeProductFilePo;
import com.caimei365.user.model.po.BaikeProductParamPo;
import com.caimei365.user.model.po.BaikeProductPo;
import com.caimei365.user.model.po.BaikeProductQuestionPo;
import com.caimei365.user.model.vo.BaikeProductFormVo;
import com.caimei365.user.model.vo.BaikeProductListVo;
import com.caimei365.user.model.vo.BaikeProductTypeVo;
import com.caimei365.user.model.vo.BaikeRecommendVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Aslee
 * @date : 2021/3/16
 */
@Mapper
public interface BaikeProductMapper {
    /**
     * 新增供应商百科商品
     */
    void insertBaikeProduct(BaikeProductPo baikeProductPo);
    /**
     * 更新供应商百科商品
     * @param baikeProductPo
     */
    void updateBaikeProduct(BaikeProductPo baikeProductPo);
    /**
     * 根据百科商品id查询供应商百科商品内容
     */
    BaikeProductFormVo getBaikeProductById(Integer productId);
    /**
     * 查询百科商品分类列表
     * @param commodityType
     */
    List<BaikeProductTypeVo> getBaikeProductTypeList(Integer commodityType);
    /**
     * 查询供应商百科商品列表
     * @param shopBaikeProductDto
     */
    List<BaikeProductListVo> getBaikeProductList(BaikeProductDto shopBaikeProductDto);

    /**
     * 更新供应商百科商品状态
     */
    void updateBaikeProductStatus(@Param("productId") Integer productId, @Param("status") Integer status);

    /**
     * 删除百科商品
     * @param productId
     */
    void deleteBaikeProduct(Integer productId);

    void deleteParamsByProductId(Integer productId);

    void deleteImagesByProductId(Integer productId);

    void deleteQuestionsByProductId(Integer productId);

    void insertProductParam(@Param("name") String name, @Param("content") String content, @Param("productId") Integer productId);

    void insertProductImage(@Param("authImage") String authImage, @Param("produtId") Integer productId, @Param("imageType") int imageType);

    void insertProductQuestion(@Param("question") String question, @Param("answer") String answer, @Param("productId") Integer productId);

    List<BaikeProductParamPo> getParamList(Integer productId);

    List<String> getImageList(@Param("productId") Integer productId, @Param("imageType") int imageType);

    List<BaikeProductQuestionPo> getQuestionList(Integer productId);

    void deleteFilesByProductId(Integer productId);

    void insertProductFile(@Param("fileTitle") String fileTitle, @Param("fileName") String fileName, @Param("ossName") String ossName, @Param("productId") Integer productId);

    List<BaikeProductFilePo> getVideoList(Integer productId);

    List<BaikeRecommendVo> getManualRecommendList(Integer productId);

    List<BaikeRecommendVo> getAutoRecommendList(@Param("shopId") Integer shopId, @Param("productTypeId") Integer productTypeId, @Param("productId") Integer productId);

    void updateRecommendType(Integer productId, Integer recommendType);

    void clearRecommendData(Integer productId);

    void insertRecommend(BaikeRecommendVo recommond);

    String getRecommendProductIds(Integer productId);

    void deleteBaikeRecommend(Integer recommendId);

    void updateRecommendSort(BaikeRecommendVo baikeRecommend);
}
